import type { Plugin } from "graphile-build";
import type { PgType, QueryBuilder, SQL } from "graphile-build-pg";
import type { GraphQLInputType, GraphQLType } from "graphql";
declare const PgConnectionArgFilterOperatorsPlugin: Plugin;
export interface OperatorSpec {
    name?: string;
    description: string;
    resolveInput?: (input: unknown) => unknown;
    resolveSql?: any;
    resolveSqlIdentifier?: (sqlIdentifier: SQL, pgType: PgType, pgTypeModifier: number | null) => SQL;
    resolveSqlValue?: (input: unknown, pgType: PgType, pgTypeModifier: number | null, resolveListItemSqlValue?: any) => SQL | null;
    resolveType?: (fieldInputType: GraphQLInputType, rangeElementInputType: GraphQLInputType) => GraphQLType;
    resolve: (sqlIdentifier: SQL, sqlValue: SQL, input: unknown, parentFieldName: string, queryBuilder: QueryBuilder) => SQL | null;
}
export default PgConnectionArgFilterOperatorsPlugin;
